#! /bin/bash

if [ "$2" == "" ]; then
    echo " usage: results.sh <times> <file>"
    exit 1
fi

each=$1
FILE=$2

function times {

     #echo "scale=2; (($1-$2)*100)/$1" | bc
    echo -n `echo "scale=2; ($1/$2)" | bc`
    echo "x"
}

function perc {

    echo "scale=2; (($1-$2)*100)/$1" | bc
}

Stk="10M"
ONCE="1"
hand=`./average.sh $each "java Simplify $FILE 0"`;
vis=`./average.sh $each "java Simplify $FILE 1"`;
inln=`./average.sh $each "java Simplify $FILE 2"`;
heap=`./average.sh $each "java Simplify $FILE 3"`;
stat=`./average.sh $each "java Simplify $FILE 4"`;
seq=`./average.sh $each "java Simplify $FILE 5"`;

echo "        Type      | Avg | Min | Max"
echo "{\sc         Hand} & $hand \\\\\\hline"
echo "{\sc      Visitor} & $vis \\\\\\hline"
echo "{\sc      Inlined} & $inln \\\\\\hline"
echo "{\sc Inlined Heap} & $heap \\\\\\hline"
echo "{\sc       Static} & $stat \\\\\\hline"
echo "{\sc   Reflective} & $seq \\\\\\hline"

echo
